diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
index 1ace33560..befa6e0e7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
@@ -11,18 +11,21 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.tool.ItemToolShears;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicRope
     extends BlockLogic {
     public static final int MASK_ROPE_CONNECT = 0b1000_0000;
+
     public BlockLogicRope(@NotNull Block<?> block) {
-        super(block, Material.cloth);
+        super(block, Materials.CLOTH);
     }
 
     @Override
@@ -36,28 +39,29 @@ public class BlockLogicRope
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public boolean isClimbable(@NotNull World world, @NotNull TilePos tilePos) {
+    public boolean isClimbable(@NotNull World world, @NotNull TilePosc tilePos) {
         return true;
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
-        boolean hasBlockNegX = source.getBlockId(tilePos.add(-1,  0,  0)) == this.id();
-        boolean hasBlockPosX = source.getBlockId(tilePos.add( 1,  0,  0)) == this.id();
-        boolean hasBlockNegY = source.getBlockId(tilePos.add( 0, -1,  0)) == this.id();
-        boolean hasBlockPosY = source.getBlockId(tilePos.add( 0,  1,  0)) == this.id() || source.isBlockOpaqueCube(tilePos.add(0, 1, 0));
-        boolean hasBlockNegZ = source.getBlockId(tilePos.add( 0,  0, -1)) == this.id();
-        boolean hasBlockPosZ = source.getBlockId(tilePos.add( 0,  0,  1)) == this.id();
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        boolean hasBlockNegX = source.getBlockId(tilePos.add(-1, 0, 0, queryPos)) == this.id();
+        boolean hasBlockPosX = source.getBlockId(tilePos.add(1, 0, 0, queryPos)) == this.id();
+        boolean hasBlockNegY = source.getBlockId(tilePos.add(0, -1, 0, queryPos)) == this.id();
+        boolean hasBlockPosY = source.getBlockId(tilePos.add(0, 1, 0, queryPos)) == this.id() || source.isBlockOpaqueCube(tilePos.add(0, 1, 0, queryPos));
+        boolean hasBlockNegZ = source.getBlockId(tilePos.add(0, 0, -1, queryPos)) == this.id();
+        boolean hasBlockPosZ = source.getBlockId(tilePos.add(0, 0, 1, queryPos)) == this.id();
 
         float minX = 5 / 16.0f;
         float maxX = 11 / 16.0f;
@@ -73,24 +77,24 @@ public class BlockLogicRope
         if (hasBlockNegZ) minZ = 0;
         if (hasBlockPosZ) maxZ = 1;
 
-        return AABB.fromPool(minX, minY, minZ, maxX, maxY, maxZ);
+        return new AABBd(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemToolShears) {
             int meta = world.getBlockData(tilePos);
             int forceRope = (~meta) & MASK_ROPE_CONNECT;
             world.setBlockDataNotify(tilePos, forceRope | (meta & ~MASK_ROPE_CONNECT));
             heldItem.damageItem(1, player);
-            if (heldItem.stackSize <= 0){
+            if (heldItem.stackSize <= 0) {
                 player.destroyCurrentEquippedItem();
             }
             return true;
         }
 
-        if(heldItem == null) {
+        if (heldItem == null) {
             pickUpRope(world, tilePos, player);
             return true;
         }
@@ -98,60 +102,62 @@ public class BlockLogicRope
         return false;
     }
 
-    public void pickUpRope(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player) {
-    	if(world.isClientSide || world.getBlock(tilePos) != this.block) {
-    		return;
-    	}
-    	
-    	final int highestRope = tilePos.y;
-        int y = tilePos.y;
-    	// Find the position of the lowest rope
-    	while(tilePos.y > 0) {
-    		Block<?> block = world.getBlock(tilePos.down());
-    		if(block != this.block) {
-    			break;
-    		}
-    		y--;
-    	}
-    	final int lowestRope = y;
-    	
-    	// Determine how many ropes fit into the players inventory
-    	int freeSpace = 0;
-    	for(int i=0; i < player.inventory.mainInventory.length; i++) {
-    		ItemStack stack = player.inventory.mainInventory[i];
-    		if(stack == null) {
-    			freeSpace += Items.ROPE.getItemStackLimit(null);
-    			continue;
-    		}
-    		if(stack.getItem() == Items.ROPE) {
-    			freeSpace += Items.ROPE.getItemStackLimit(null) - stack.stackSize;	
-    		}
-    	}
-    	freeSpace = Math.min(freeSpace, 1);
-    	
-    	int ropesCollected = 0;
-    	for(y = lowestRope; y <= highestRope; y++) {
-    		if(ropesCollected >= freeSpace) {
-    			break;
-    		}
-    		world.setBlockIdNotify(tilePos, 0);
-    		ropesCollected++;
-    	}
-    	
-    	if(player.getGamemode().consumeBlocks()) {
-    		ItemStack stack = new ItemStack(Items.ROPE, ropesCollected);
-    		player.inventory.insertItem(stack, true);
-    		if(stack.stackSize > 0) {
-        		// this shouldnt happen
-        		player.dropPlayerItem(stack);
-        	}	
-    	}
-    	
-    	world.playBlockSoundEffect(player, tilePos.x + 0.5, highestRope + 0.5, tilePos.z + 0.5, block, EnumBlockSoundEffectType.PLACE);
+    public void pickUpRope(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player) {
+        if (world.isClientSide || world.getBlock(tilePos) != this.block) {
+            return;
+        }
+
+        TilePos queryPos = new TilePos();
+
+        final int highestRope = tilePos.y();
+        int y = tilePos.y();
+        // Find the position of the lowest rope
+        while (tilePos.y() > 0) {
+            Block<?> block = world.getBlock(tilePos.down(queryPos));
+            if (block != this.block) {
+                break;
+            }
+            y--;
+        }
+        final int lowestRope = y;
+
+        // Determine how many ropes fit into the players inventory
+        int freeSpace = 0;
+        for (int i = 0; i < player.inventory.mainInventory.length; i++) {
+            ItemStack stack = player.inventory.mainInventory[i];
+            if (stack == null) {
+                freeSpace += Items.ROPE.getItemStackLimit(null);
+                continue;
+            }
+            if (stack.getItem() == Items.ROPE) {
+                freeSpace += Items.ROPE.getItemStackLimit(null) - stack.stackSize;
+            }
+        }
+        freeSpace = Math.min(freeSpace, 1);
+
+        int ropesCollected = 0;
+        for (y = lowestRope; y <= highestRope; y++) {
+            if (ropesCollected >= freeSpace) {
+                break;
+            }
+            world.setBlockIdNotify(tilePos, 0);
+            ropesCollected++;
+        }
+
+        if (player.getGamemode().consumeBlocks()) {
+            ItemStack stack = new ItemStack(Items.ROPE, ropesCollected);
+            player.inventory.insertItem(stack, true);
+            if (stack.stackSize > 0) {
+                // this shouldnt happen
+                player.dropPlayerItem(stack);
+            }
+        }
+
+        world.playBlockSoundEffect(player, tilePos.x() + 0.5, highestRope + 0.5, tilePos.z() + 0.5, this.block, EnumBlockSoundEffectType.PLACE);
     }
 
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
-        return new ItemStack[] { new ItemStack(Items.ROPE) };
+        return new ItemStack[]{new ItemStack(Items.ROPE)};
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
index cfb2e43f9..7b699fbe7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
@@ -6,16 +6,17 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public abstract class BlockLogicRotatable extends BlockLogic {
     public static final int MASK_DIRECTION = 0b0000_0111;
+
     public BlockLogicRotatable(@NotNull Block<?> block, @NotNull Material material) {
         super(block, material);
     }
 
-    public static @NotNull Direction getDirectionFromMeta(int meta)
-    {
+    public static @NotNull Direction getDirectionFromMeta(int meta) {
         return Direction.getDirectionById(meta & MASK_DIRECTION);
     }
 
@@ -24,36 +25,36 @@ public abstract class BlockLogicRotatable extends BlockLogic {
     }
 
     @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
+    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
         world.setBlockDataNotify(tilePos, mob.getHorizontalPlacementDirection(side).getOpposite().getId());
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if (!side.isHorizontal()) side = Side.SOUTH;
         world.setBlockDataNotify(tilePos, BlockLogicRotatable.setDirection(0, side.getDirection()));
     }
 
-    public static void setDefaultDirection(@NotNull World world, @NotNull TilePos tilePos)
-    {
-        if(world.isClientSide) {
+    public static void setDefaultDirection(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (world.isClientSide) {
             return;
         }
-        int bN = world.getBlockId(tilePos.add(Direction.NORTH));
-        int bS = world.getBlockId(tilePos.add(Direction.SOUTH));
-        int bW = world.getBlockId(tilePos.add(Direction.WEST));
-        int bE = world.getBlockId(tilePos.add(Direction.EAST));
+        TilePos queryPos = new TilePos();
+        int bN = world.getBlockId(tilePos.north(queryPos));
+        int bS = world.getBlockId(tilePos.south(queryPos));
+        int bW = world.getBlockId(tilePos.west(queryPos));
+        int bE = world.getBlockId(tilePos.east(queryPos));
         Direction direction = Direction.NORTH;
-        if(Blocks.solid[bN] && !Blocks.solid[bS]) {
+        if (Blocks.solid[bN] && !Blocks.solid[bS]) {
             direction = Direction.SOUTH;
         }
-        if(Blocks.solid[bS] && !Blocks.solid[bN]) {
+        if (Blocks.solid[bS] && !Blocks.solid[bN]) {
             direction = Direction.NORTH;
         }
-        if(Blocks.solid[bW] && !Blocks.solid[bE]) {
+        if (Blocks.solid[bW] && !Blocks.solid[bE]) {
             direction = Direction.EAST;
         }
-        if(Blocks.solid[bE] && !Blocks.solid[bW]) {
+        if (Blocks.solid[bE] && !Blocks.solid[bW]) {
             direction = Direction.WEST;
         }
         world.setBlockDataNotify(tilePos, setDirection(world.getBlockData(tilePos), direction));
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
index ec6802be9..fd717f85d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
@@ -1,10 +1,11 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.EntityFallingBlock;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -13,40 +14,43 @@ public class BlockLogicSand extends BlockLogic {
     public static boolean fallInstantly = false;
 
     public BlockLogicSand(@NotNull Block<?> block) {
-        super(block, Material.sand);
+        super(block, Materials.SAND);
     }
 
     @Override
-	public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos)
+	public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos)
     {
         world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
     }
 
     @Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id)
+	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id)
     {
         world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
+	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         tryToFall(world, tilePos);
     }
 
-    private void tryToFall(@NotNull World world, @NotNull TilePos tilePos) {
-        if(canFallBelow(world, tilePos.down()) && tilePos.y >= 0) {
+    private void tryToFall(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        if(canFallBelow(world, tilePos.down(queryPos)) && tilePos.y() >= 0) {
             byte radius = 32;
-            if(fallInstantly || !world.areBlocksLoaded(tilePos.add(-radius, -radius, -radius), tilePos.add(radius, radius, radius))) {
+            if(fallInstantly || !world.areBlocksLoaded(tilePos.add(-radius, -radius, -radius, new TilePos()), tilePos.add(radius, radius, radius, new TilePos()))) {
                 world.setBlockIdNotify(tilePos, 0);
-                TilePos p = new TilePos(tilePos.x, tilePos.y - 1, tilePos.z);
-                while (canFallBelow(world, p) && p.y > 0) {
-                    p.y--;
+                int checkX = tilePos.x();
+                int checkY = tilePos.y() - 1;
+                int checkZ = tilePos.z();
+                while (canFallBelow(world, queryPos.set(checkX, checkY, checkZ)) && checkY > 0) {
+                    checkY--;
                 }
-                if(p.y > 0) {
-                    world.setBlockIdNotify(p, this.block.id());
+                if(checkY > 0) {
+                    world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
                 }
             } else {
-                EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, tilePos.x + 0.5, tilePos.y + 0.5, tilePos.z + 0.5, this.block.id(), 0, null);
+                EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, tilePos.x() + 0.5, tilePos.y() + 0.5, tilePos.z() + 0.5, this.block.id(), 0, null);
                 world.entityJoinedWorld(entityFallingBlock);
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
index 5c0d0f6fc..1ac8e43aa 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
@@ -9,57 +9,56 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements IBonemealable
-{
-	public boolean canGrowOnSand = false;
+public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements IBonemealable {
+    public boolean canGrowOnSand = false;
 
-	public BlockLogicSaplingBase(@NotNull Block<?> block) {
+    public BlockLogicSaplingBase(@NotNull Block<?> block) {
         super(block);
         float f = 0.4F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 2.0F, 0.5F + f);
     }
 
-	@Override
-	public boolean mayPlaceOn(int blockId)
-    {
+    @Override
+    public boolean mayPlaceOn(int blockId) {
         return blockId == Blocks.SAND.id() || super.mayPlaceOn(blockId);
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
-        if(world.isClientSide) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (world.isClientSide) {
             return;
         }
 
-        if(!this.canGrowOnSand) {
-            if(world.getBlockId(tilePos.down()) == Blocks.SAND.id()) {
+        TilePos queryPos = new TilePos();
+
+        if (!this.canGrowOnSand) {
+            if (world.getBlockId(tilePos.down(queryPos)) == Blocks.SAND.id()) {
                 world.setBlockIdNotify(tilePos, Blocks.DEADBUSH.id());
-            }	
+            }
         }
 
         super.updateTick(world, tilePos, rand, isRandomTick);
         int growthRate = 30;
-        if(world.getSeasonManager().getCurrentSeason() != null){
+        if (world.getSeasonManager().getCurrentSeason() != null) {
             growthRate = MathHelper.floor_float(growthRate / world.getSeasonManager().getCurrentSeason().cropGrowthFactor);
         }
-        if(world.getBlockLightValue(tilePos.up()) >= 9 && rand.nextInt(growthRate) == 0) {
+        if (world.getBlockLightValue(tilePos.up(queryPos)) >= 9 && rand.nextInt(growthRate) == 0) {
             int l = world.getBlockData(tilePos);
-            if((l & 8) == 0)
-            {
+            if ((l & 8) == 0) {
                 world.setBlockDataNotify(tilePos, l | 8);
-            } else
-            {
+            } else {
                 growTree(world, tilePos, rand);
             }
         }
     }
-    
+
     @Override
-    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit){
-        if(!world.isClientSide) {
+    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+        if (!world.isClientSide) {
             growTree(world, tilePos, world.rand);
             if (player == null || player.getGamemode().consumeBlocks()) {
                 itemStack.stackSize--;
@@ -68,5 +67,5 @@ public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements
         return true;
     }
 
-    public abstract void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random);
+    public abstract void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java
index 3b5ae3ebd..fa5d545e0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java
@@ -3,30 +3,26 @@ package net.minecraft.core.block;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.WorldFeature;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicSaplingBirch extends BlockLogicSaplingBase
-{
+public class BlockLogicSaplingBirch extends BlockLogicSaplingBase {
 
-	public BlockLogicSaplingBirch(@NotNull Block<?> block)
-    {
+    public BlockLogicSaplingBirch(@NotNull Block<?> block) {
         super(block);
     }
 
 
     @Override
-	public void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random)
-    {
+    public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
 
         world.setBlockId(tilePos, 0);
 
         WorldFeature tree = new WorldFeatureTree(Blocks.LEAVES_BIRCH.id(), Blocks.LOG_BIRCH.id(), 5);
 
-        if(!tree.place(world, random, tilePos.x, tilePos.y, tilePos.z))
-        {
+        if (!tree.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
             world.setBlockId(tilePos, id());
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java
index 7f13e5e20..6f3846cea 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java
@@ -3,27 +3,24 @@ package net.minecraft.core.block;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicSaplingCacao extends BlockLogicSaplingBase
-{
+public class BlockLogicSaplingCacao extends BlockLogicSaplingBase {
 
-    public BlockLogicSaplingCacao(@NotNull Block<?> block)
-    {
+    public BlockLogicSaplingCacao(@NotNull Block<?> block) {
         super(block);
     }
 
     @Override
-    public void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random) {
+    public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
         WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_CACAO.id(), Blocks.LOG_OAK_MOSSY.id(), 4);
         world.setBlockId(tilePos, 0);
 
-        if(!treeSmall.place(world, random, tilePos.x, tilePos.y, tilePos.z))
-        {
-                world.setBlockId(tilePos, id());
+        if (!treeSmall.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
+            world.setBlockId(tilePos, id());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
index adc4da5b8..baa36b440 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
@@ -6,27 +6,23 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureCherryTreeFancy;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCherry;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
-public class BlockLogicSaplingCherry extends BlockLogicSaplingBase
-{
+public class BlockLogicSaplingCherry extends BlockLogicSaplingBase {
 
-	public BlockLogicSaplingCherry(@NotNull Block<?> block)
-    {
+    public BlockLogicSaplingCherry(@NotNull Block<?> block) {
         super(block);
     }
 
     @Override
-	public void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random)
-    {
-        WorldFeature treeBig  = new WorldFeatureCherryTreeFancy(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id());
+    public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
+        WorldFeature treeBig = new WorldFeatureCherryTreeFancy(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id());
         WorldFeature treeSmall = new WorldFeatureTreeCherry(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id(), 4);
         world.setBlockId(tilePos, 0);
 
-        if(!treeSmall.place(world, random, tilePos.x, tilePos.y, tilePos.z))
-        {
-            if(!treeBig.place(world, random, tilePos.x, tilePos.y, tilePos.z)) {
+        if (!treeSmall.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
+            if (!treeBig.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
                 world.setBlockId(tilePos, id());
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java
index d0bc4fe27..5a5341728 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java
@@ -3,29 +3,25 @@ package net.minecraft.core.block;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeEucalyptus;
 import net.minecraft.core.world.generate.feature.WorldFeature;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicSaplingEucalyptus extends BlockLogicSaplingBase
-{
+public class BlockLogicSaplingEucalyptus extends BlockLogicSaplingBase {
 
-	public BlockLogicSaplingEucalyptus(@NotNull Block<?> block)
-    {
+    public BlockLogicSaplingEucalyptus(@NotNull Block<?> block) {
         super(block);
     }
-    
+
     @Override
-	public void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random)
-    {
+    public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
 
         world.setBlockId(tilePos, 0);
 
         WorldFeature tree = new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id(), Blocks.LOG_EUCALYPTUS.id());
         tree.init(1.0D, 1.0D, 1.0D);
-        if(!tree.place(world, random, tilePos.x, tilePos.y, tilePos.z))
-        {
+        if (!tree.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
             world.setBlockId(tilePos, id());
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java
index 98cca61b1..441e77d3c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java
@@ -4,29 +4,25 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 import net.minecraft.core.world.generate.feature.WorldFeature;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicSaplingOak extends BlockLogicSaplingBase
-{
+public class BlockLogicSaplingOak extends BlockLogicSaplingBase {
 
-	public BlockLogicSaplingOak(@NotNull Block<?> block)
-    {
+    public BlockLogicSaplingOak(@NotNull Block<?> block) {
         super(block);
     }
-    
+
     @Override
-	public void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random)
-    {
-    	WorldFeature treeBig = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id());
+    public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
+        WorldFeature treeBig = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id());
         WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
-    	world.setBlockId(tilePos, 0);
+        world.setBlockId(tilePos, 0);
 
-        if(!treeSmall.place(world, random, tilePos.x, tilePos.y, tilePos.z))
-        {
-            if(!treeBig.place(world, random, tilePos.x, tilePos.y, tilePos.z)) {
+        if (!treeSmall.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
+            if (!treeBig.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
                 world.setBlockId(tilePos, id());
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java
index ca9bf7b35..f6b7351f0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java
@@ -5,21 +5,22 @@ import java.util.Random;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreePalm;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicSaplingPalm extends BlockLogicSaplingBase {
 
-	public BlockLogicSaplingPalm(@NotNull Block<?> block) {
-		super(block);
-		
-		this.canGrowOnSand = true;
-	}
-	
-	@Override
-	public void growTree(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random random) {
-    	boolean big = world.getBlockId(tilePos.down()) != Blocks.SAND.id();
-    	
-    	new WorldFeatureTreePalm(Blocks.LOG_PALM, Blocks.LEAVES_PALM, big, true, false).place(world, random, tilePos.x, tilePos.y, tilePos.z);
-	}
+    public BlockLogicSaplingPalm(@NotNull Block<?> block) {
+        super(block);
+
+        this.canGrowOnSand = true;
+    }
+
+    @Override
+    public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
+        boolean big = world.getBlockId(tilePos.down(new TilePos())) != Blocks.SAND.id();
+
+        new WorldFeatureTreePalm(Blocks.LOG_PALM, Blocks.LEAVES_PALM, big, true, false).place(world, random, tilePos.x(), tilePos.y(), tilePos.z());
+    }
 
 }
